﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public Parser As BeaconParser	
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public scanning As Boolean
	
	Public beacons As Map
	Public const TIME_TO_LIVE_SECONDS As Int = 5
	Private Timer1 As Timer
	Public rp as RuntimePermissions
End Sub

Sub Service_Create
	manager.Initialize("manager")
	beacons.Initialize
	Timer1.Initialize("timer1", TIME_TO_LIVE_SECONDS * DateTime.TicksPerSecond)
	Timer1.Enabled = True
	Parser.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Scan
	manager.Scan2(Null, True)
	scanning = True
End Sub


Public Sub StopScan
	manager.StopScan
	scanning = False
End Sub

Private Sub Timer1_Tick
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Main, "StateChanged")
End Sub


Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Dim beacon As Beacon = Parser.Parse(AdvertisingData, RSSI)
	If beacon <> Null Then
		beacons.Put(beacon.uniqueid, beacon)
		CallSub(Main, "StateChanged")
	End If
End Sub





'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
